namespace CMSMicroservice.Application.ClubMembershipCQ.Commands.ActivateClubMembership;

public class ActivateClubMembershipCommandValidator : AbstractValidator<ActivateClubMembershipCommand>
{
    public ActivateClubMembershipCommandValidator()
    {
        RuleFor(x => x.UserId)
            .GreaterThan(0)
            .WithMessage("شناسه کاربر معتبر نیست");
    }

    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(
            ValidationContext<ActivateClubMembershipCommand>.CreateWithOptions(
                (ActivateClubMembershipCommand)model, 
                x => x.IncludeProperties(propertyName)));
        
        if (result.IsValid)
            return Array.Empty<string>();
        
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
